/*
 * This is part of the ANL/MCS/FL CAVEav distribution.
 *     written by Ivan R. Judson
 *
 */


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <cave_ogl.h>

#include <CAVEav.h>

void draw_func(void);
int parse_args(int ac, char **av);

static CAVtv *tv = NULL;

main(int argc,char **argv)
{
  CAVEConfigure(&argc, argv, NULL);


  if(parse_args(argc, argv) < 0)
    {
      perror("Can't parse arguments!");
      CAVEExit();
    }

  CAVEInit();

  if(tv != NULL)
    tv->Init();

  CAVEDisplay(draw_func, 0);
    
  while (!CAVEgetbutton(CAVE_ESCKEY))
    {
    }

  if(tv != NULL)
    delete tv;
  
  CAVEExit();

  return(0);
}

//
// The users drawing function
//

void draw_func(void)
{
  // Clear the screen

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Draw the tv and it's contents
  if(tv != NULL)
    {
      glTranslatef(0.0, 5.0, -5.0);
      tv->Draw();
    }
}

//
// Very ugly example routine to parse command-line arguments and 
// configure the CAVcam's accordingly.  
// USE THE GETOPT LIBRARY IF YOU CAN
//

int parse_args(int ac, char **av)
{
  int i;

  for(i = 0; i < ac; i++)
    {
      if(strcmp(av[i], "-tv") == 0)
	{
	  if(i + 1 >= ac || av[i+1][0] == '-') {
	    perror("-tv (No specifications, net|file)");
	  } else {
	    if(strcmp(av[i+1], "net") == 0)
	      {
		tv = new netCAVtv(av[i+2], atoi(av[i+3]));
		fprintf(stderr, "Created new net tv\n");
		i += 3;
	      } else if(strcmp(av[i+1], "file") == 0) {
		tv = new fileCAVtv(av[i+2], atoi(av[i+3]), atoi(av[i+4]), 
				   atoi(av[i+5]), 0.0, 5.0, -5.0);
		fprintf(stderr, "Created new file tv\n");
		i += 5;
	      }
	  }
	} else if(strcmp(av[i], "-usage") == 0 ||
		  strcmp(av[i], "-help") == 0) {
	  fprintf(stderr, "%s:", av[0]);
	  fprintf(stderr, "\t-tv [ net <net spec> | file <file spec> ]\n");
	  fprintf(stderr, "\t<net spec> : hostname port\n");
	  fprintf(stderr, "\t<file spec> : filename (including path) X Y Z\n");
	  CAVEExit();
	}
    }
  return(1);
}
